/********************************************************************
	Rhapsody	: 8.2.1 
	Login		: fandras
	Component	: DisplayApplication 
	Configuration 	: DefaultConfig
	Model Element	: TemperatureSubscriber
//!	Generated Date	: Tue, 4, Jul 2017  
	File Path	: DisplayApplication\DefaultConfig\TemperatureSubscriber.cpp
*********************************************************************/

//## auto_generated
#include "TemperatureSubscriber.h"
//##   ignore
#include "MainDisplayApplication.h"
//##   ignore
#include "DisplayPkg.h"
//##   ignore
#include "TemperatureReaderListener.h"
//## attribute TemperatureReader
#include "TemperaturePkg_IDLSupport.h"
//## package DisplayPkg

//## class TemperatureSubscriber
TemperatureSubscriber::TemperatureSubscriber() {
    initSubscriber();
    //#[ operation TemperatureSubscriber()
    printf("ready to receive data\n");
    //#]
}

TemperatureSubscriber::~TemperatureSubscriber() {
    cleanupSubscriber();
}

TemperatureTopicStructDataReader* TemperatureSubscriber::getTemperatureReader() const {
    return TemperatureReader;
}

void TemperatureSubscriber::setTemperatureReader(TemperatureTopicStructDataReader * p_TemperatureReader) {
    TemperatureReader = p_TemperatureReader;
}

//#[ ignore
DDS::Subscriber* TemperatureSubscriber::getSubscriber() {
    return subscriber;
}

void TemperatureSubscriber::initSubscriber() {
    DDS::DomainParticipant* domainParticipant = DisplayApplicationDP::instance()->getDomainParticipant();
    if (domainParticipant != NULL)
    {
    	subscriber = domainParticipant->create_subscriber(DDS::SUBSCRIBER_QOS_DEFAULT, NULL, 0);
    	if (subscriber != NULL)
    	{		
    		DDS::TopicDescription* TemperatureTopicTopicDesc = DisplayApplicationDP::instance()->lookupTopicDescription("TemperatureTopic");
    		if (TemperatureTopicTopicDesc != NULL)
    		{
    			DDS::DataReaderListener* TemperatureReaderListener = dynamic_cast<DDS::DataReaderListener*>(&itsTemperatureReaderListener);
    		
    			DDS::DataReader* dataReader = subscriber->create_datareader(TemperatureTopicTopicDesc, DDS::DATAREADER_QOS_DEFAULT, TemperatureReaderListener, DDS::DATA_AVAILABLE_STATUS);		
    			TemperatureReader = dynamic_cast<TemperatureTopicStructDataReader*>(dataReader);
    		}
    	}
    }
}

void TemperatureSubscriber::cleanupSubscriber() {
    if (subscriber != NULL) 
    {
    	subscriber->delete_contained_entities();
    	DDS::DomainParticipant* domainParticipant = subscriber->get_participant();
    	domainParticipant->delete_subscriber(subscriber);
    	subscriber = NULL;
    }
}
//#]

/*********************************************************************
	File Path	: DisplayApplication\DefaultConfig\TemperatureSubscriber.cpp
*********************************************************************/
