/********************************************************************
	Rhapsody	: 8.2.1 
	Login		: fandras
	Component	: TemperatureInsideApplication 
	Configuration 	: DefaultConfig
	Model Element	: DefaultConfig
//!	Generated Date	: Tue, 4, Jul 2017  
	File Path	: TemperatureInsideApplication\DefaultConfig\MainTemperatureInsideApplication.cpp
*********************************************************************/

//## auto_generated
#include "MainTemperatureInsideApplication.h"
//## auto_generated
#include "ThermometerInside.h"
//#[ ignore
TemperatureInsideApplicationDP::TemperatureInsideApplicationDP() {
    DDS::DomainParticipantFactory* dpf = DDS::DomainParticipantFactory::get_instance();
    if (dpf != NULL)
    {
    	domainParticipant = dpf->create_participant(0, DDS::PARTICIPANT_QOS_DEFAULT, NULL, 0);
    	if (domainParticipant != NULL) 
    	{
    		TemperatureTopicStructTypeSupport::register_type(domainParticipant, TemperatureTopicStructTypeSupport::get_type_name());
    		domainParticipant->create_topic("TemperatureTopic", TemperatureTopicStructTypeSupport::get_type_name(), DDS::TOPIC_QOS_DEFAULT, NULL, 0);
    	}
    }
}

TemperatureInsideApplicationDP::~TemperatureInsideApplicationDP() {
    if (domainParticipant != NULL) {
    	domainParticipant->delete_contained_entities();
    }
}

DDS::DomainParticipant* TemperatureInsideApplicationDP::getDomainParticipant() {
    return domainParticipant;
}

DDS::TopicDescription* TemperatureInsideApplicationDP::lookupTopicDescription(char* topicName) {
    DDS::TopicDescription* retVal = NULL;
    if (domainParticipant != NULL)
    {
    	retVal = domainParticipant->lookup_topicdescription(topicName);
    }
    return retVal;
}

TemperatureInsideApplicationDP* TemperatureInsideApplicationDP::instance() {
    static TemperatureInsideApplicationDP rhpDomainParticipant;
    return &rhpDomainParticipant;
}
//#]

int main(int argc, char* argv[]) {
    int status = 0;
    if(OXF::initialize())
        {
            ThermometerInside * p_ThermometerInside;
            p_ThermometerInside = new ThermometerInside;
            //#[ configuration TemperatureInsideApplication::DefaultConfig 
            	std::cout << "Publishing..." << std::endl;
            
                p_ThermometerInside->publishOne();
            //#]
            OXF::start();
            delete p_ThermometerInside;
            status = 0;
        }
    else
        {
            status = 1;
        }
    return status;
}

/*********************************************************************
	File Path	: TemperatureInsideApplication\DefaultConfig\MainTemperatureInsideApplication.cpp
*********************************************************************/
