/********************************************************************
	Rhapsody	: 8.2.1
	Login		: fandras
	Component	: ThermometerOutside
	Configuration 	: DefaultConfig
	Model Element	: DefaultConfig
//!	Generated Date	: Wed, 5, Jul 2017
	File Path	: ThermometerOutside\DefaultConfig\MainThermometerOutside.cpp
*********************************************************************/

//## auto_generated
#include "MainThermometerOutside.h"
//## auto_generated
#include "ThermometerOutsidePublisher.h"
//#[ ignore
ThermometerOutsideDP::ThermometerOutsideDP() {
    DDS::DomainParticipantFactory* dpf = DDS::DomainParticipantFactory::get_instance();
    if (dpf != NULL)
    {
    	domainParticipant = dpf->create_participant(0, DDS::PARTICIPANT_QOS_DEFAULT, NULL, 0);
    	if (domainParticipant != NULL)
    	{
    		TemperatureTopicStructTypeSupport::register_type(domainParticipant, TemperatureTopicStructTypeSupport::get_type_name());
    		domainParticipant->create_topic("TemperatureTopic", TemperatureTopicStructTypeSupport::get_type_name(), DDS::TOPIC_QOS_DEFAULT, NULL, 0);
    	}
    }
}

ThermometerOutsideDP::~ThermometerOutsideDP() {
    if (domainParticipant != NULL) {
    	domainParticipant->delete_contained_entities();
    }
}

DDS::DomainParticipant* ThermometerOutsideDP::getDomainParticipant() {
    return domainParticipant;
}

DDS::TopicDescription* ThermometerOutsideDP::lookupTopicDescription(char* topicName) {
    DDS::TopicDescription* retVal = NULL;
    if (domainParticipant != NULL)
    {
    	retVal = domainParticipant->lookup_topicdescription(topicName);
    }
    return retVal;
}

ThermometerOutsideDP* ThermometerOutsideDP::instance() {
    static ThermometerOutsideDP rhpDomainParticipant;
    return &rhpDomainParticipant;
}
//#]

int main(int argc, char* argv[]) {
    int status = 0;
    if(OXF::initialize())
        {
            ThermometerOutsidePublisher * p_ThermometerOutsidePublisher;
            p_ThermometerOutsidePublisher = new ThermometerOutsidePublisher;
            //#[ configuration ThermometerOutside::DefaultConfig
            p_ThermometerOutsidePublisher->publishOne();
            //#]
            OXF::start();
            delete p_ThermometerOutsidePublisher;
            status = 0;
        }
    else
        {
            status = 1;
        }
    return status;
}

/*********************************************************************
	File Path	: ThermometerOutside\DefaultConfig\MainThermometerOutside.cpp
*********************************************************************/
