/********************************************************************
	Rhapsody	: 8.2.1 
	Login		: fandras
	Component	: DisplayApplication 
	Configuration 	: DefaultConfig
	Model Element	: DefaultConfig
//!	Generated Date	: Tue, 4, Jul 2017  
	File Path	: DisplayApplication\DefaultConfig\MainDisplayApplication.cpp
*********************************************************************/

//## auto_generated
#include "MainDisplayApplication.h"
//## auto_generated
#include "TemperatureReaderListener.h"
//## auto_generated
#include "TemperatureSubscriber.h"
//#[ ignore
DisplayApplicationDP::DisplayApplicationDP() {
    DDS::DomainParticipantFactory* dpf = DDS::DomainParticipantFactory::get_instance();
    if (dpf != NULL)
    {
    	domainParticipant = dpf->create_participant(0, DDS::PARTICIPANT_QOS_DEFAULT, NULL, 0);
    	if (domainParticipant != NULL) 
    	{
    		TemperatureTopicStructTypeSupport::register_type(domainParticipant, TemperatureTopicStructTypeSupport::get_type_name());
    		domainParticipant->create_topic("TemperatureTopic", TemperatureTopicStructTypeSupport::get_type_name(), DDS::TOPIC_QOS_DEFAULT, NULL, 0);
    	}
    }
}

DisplayApplicationDP::~DisplayApplicationDP() {
    if (domainParticipant != NULL) {
    	domainParticipant->delete_contained_entities();
    }
}

DDS::DomainParticipant* DisplayApplicationDP::getDomainParticipant() {
    return domainParticipant;
}

DDS::TopicDescription* DisplayApplicationDP::lookupTopicDescription(char* topicName) {
    DDS::TopicDescription* retVal = NULL;
    if (domainParticipant != NULL)
    {
    	retVal = domainParticipant->lookup_topicdescription(topicName);
    }
    return retVal;
}

DisplayApplicationDP* DisplayApplicationDP::instance() {
    static DisplayApplicationDP rhpDomainParticipant;
    return &rhpDomainParticipant;
}
//#]

int main(int argc, char* argv[]) {
    int status = 0;
    if(OXF::initialize())
        {
            TemperatureReaderListener * p_TemperatureReaderListener;
            TemperatureSubscriber * p_TemperatureSubscriber;
            p_TemperatureReaderListener = new TemperatureReaderListener;
            p_TemperatureSubscriber = new TemperatureSubscriber;
            //#[ configuration DisplayApplication::DefaultConfig 
            DDS_Duration_t receive_period = {1,0};
            for (;;) {
              printf("Sleeping... \n");
              NDDSUtility::sleep(receive_period);
            }
            //#]
            OXF::start();
            delete p_TemperatureReaderListener;
            delete p_TemperatureSubscriber;
            status = 0;
        }
    else
        {
            status = 1;
        }
    return status;
}

/*********************************************************************
	File Path	: DisplayApplication\DefaultConfig\MainDisplayApplication.cpp
*********************************************************************/
